=== 3rdparty/IniProcessor/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.2...4.0)

project (IniProcessing)

# Enable Testing
enable_testing ()

# Set C++11
set(CMAKE_CXX_STANDARD 11)

# Add test
add_subdirectory (test)
