=== debian/changelog ===
thextech-smbx (1.3.6-1ppa0) oneiric; urgency=low

  * All changes shown at the included changelog.txt file

 -- Vitaly Novichkov <admin@wohlnet.ru>  Tue, 04 Jan 2022 22:16:54 +0300
